﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Syncer
{
	/// <summary>
	/// Instruction that specifies what should be synced.
	/// </summary>
	[Serializable]
	public class SyncInstruction
	{
		public SyncInstruction(string sourceDirectory, string destinationDirectory, List<string> filters = null)
		{
			if (sourceDirectory == null)
			{ throw new ArgumentNullException("sourceDirectory"); }

			if (destinationDirectory == null)
			{ throw new ArgumentNullException("destinationDirectory"); }

			SourceDirectory = sourceDirectory;
			DestinationDirectory = destinationDirectory;
		}

		public string SourceDirectory
		{ get; set; }

		public string DestinationDirectory
		{ get; set; }

		public List<string> Filters
		{ get; set; }
	}
}
